﻿Imports System.Data.OleDb
Imports System.Data.SqlClient
Imports System.Xml
Imports C1.Util.Win.Win32
Imports C1.Win.C1FlexGrid

Public Class Form1
    Dim _dt As DataTable = New DataTable()
    Dim _newRows As List(Of DataRow) = New List(Of DataRow)
    Dim _init As Boolean = False
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        C1FlexGridGroupPanel1.FlexGrid = C1FlexGrid1

        C1FlexGrid1.AllowSorting = AllowSortingEnum.MultiColumn
        C1FlexGrid1.SelectionMode = SelectionModeEnum.ListBox
        C1FlexGrid1.AutoGenerateColumns = True
        C1FlexGrid1.Cols.RemoveRange(0, C1FlexGrid1.Cols.Count)
        C1FlexGrid1.AllowEditing = False

        BackgroundWorker1.RunWorkerAsync()
    End Sub

    Private Sub BackGroundWorker_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim pageSize As Integer = 15
        Dim pageNumber As Integer = 1
        Dim startRow As Integer = 0
        Dim remainingRows As Integer = 0
        Dim dtset As New DataTable
        _init = False
        'Dim da As OleDbDataAdapter = New OleDbDataAdapter("select * from customers", GetConnectionString())
        Dim da As SqlDataAdapter = New SqlDataAdapter("select * from customers", GetSqlConnectionString())
        While True

            If Not BackgroundWorker1.CancellationPending Then

                startRow = (pageNumber - 1) * pageSize
                remainingRows = da.Fill(startRow, pageSize, dtset)
                If remainingRows = 0 Then
                    e.Result = dtset
                    Exit While
                Else
                    pageNumber += 1
                End If
            Else
                e.Result = Nothing
                e.Cancel = True
                Exit While
            End If
        End While
    End Sub

    Private Sub BackGroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        If e.Error IsNot Nothing Then
        ElseIf e.Cancelled Then

        Else
            Dim dt As DataTable = TryCast(e.Result, DataTable)
            _dt = dt
            C1FlexGrid1.DataSource = _dt
            _init = True
        End If
    End Sub

    Function GetSqlConnectionString() As String
        Return "Data Source=(localdb)\MSSQLLocalDB;Initial Catalog=C1Nwind;Integrated Security=True;"
    End Function


    Function GetConnectionString() As String
        Dim path As String = Environment.GetFolderPath(Environment.SpecialFolder.Personal) + "\ComponentOne Samples\Common"
        Dim conn As String = "provider=microsoft.jet.oledb.4.0;data source={0}\c1nwind.mdb;"
        Return String.Format(conn, path)
    End Function
    Private Function GetDataSource() As Object
        Dim dt As New DataTable()

        dt.Columns.Add("Id")
        dt.Columns.Add("Name")
        dt.Columns.Add("Position")
        dt.Columns.Add("Site")

        dt.Rows.Add(1, "Peter", "D", "Toronto")
        dt.Rows.Add(2, "George", "D", "Venice")
        dt.Rows.Add(3, "Emily", "C", "Paris")
        dt.Rows.Add(4, "Craig", "I", "Berlin")
        dt.Rows.Add(5, "Steve", "F", "Milan")
        dt.Rows.Add(6, "John", "I", "Tokyo")
        dt.Rows.Add(7, "Fred", "B", "Rome")
        dt.Rows.Add(8, "Mary", "D", "Madrid")


        Return dt
    End Function

    Private Sub saveGrid_Click(sender As Object, e As EventArgs)
        Dim zXML = New Text.StringBuilder
        Using writer As XmlWriter = XmlWriter.Create(zXML)
            writer.WriteStartElement("FlexGrid")
            writer.WriteStartElement("Definition", "")
            writer.WriteAttributeString("Filter", C1FlexGrid1.FilterDefinition)
            writer.WriteAttributeString("Sort", C1FlexGrid1.SortDefinition)
            writer.WriteAttributeString("Group", C1FlexGrid1.GroupDefinition)
            writer.WriteEndElement()
            writer.WriteEndElement()
            writer.Flush()
        End Using
        IO.File.WriteAllText(C1FlexGrid1.Name & ".xml", zXML.ToString())
    End Sub

    Private Sub restore_Click(sender As Object, e As EventArgs)
        Dim zXML As New Text.StringBuilder
        Dim content As String = IO.File.ReadAllText(C1FlexGrid1.Name & ".xml")
        zXML.Append(content)
        Using stream As IO.TextReader = New IO.StringReader(zXML.ToString)
            Using reader As XmlReader = XmlReader.Create(stream)
                reader.ReadToFollowing("Definition")
                C1FlexGrid1.GroupDefinition = IIf(reader.GetAttribute("Group") = Nothing, String.Empty, reader.GetAttribute("Group"))
                C1FlexGrid1.SortDefinition = IIf(reader.GetAttribute("Sort") = Nothing, String.Empty, reader.GetAttribute("Sort"))
                C1FlexGrid1.FilterDefinition = IIf(reader.GetAttribute("Filter") = Nothing, String.Empty, reader.GetAttribute("Filter"))
                reader.Close()
            End Using
        End Using
    End Sub

    Private Sub resetSort_Click(sender As Object, e As EventArgs)
        C1FlexGrid1.SortDefinition = String.Empty
    End Sub
    Dim listeIdLigne As List(Of Integer)
    Private Sub C1FlexGrid1_BeforeSort(sender As Object, e As SortColEventArgs) Handles C1FlexGrid1.BeforeSort
        listeIdLigne = New List(Of Integer)
        Dim i As Integer
        Dim ssg As C1.Win.C1FlexGrid.C1FlexGrid
        ssg = sender

        If ssg.SelectionMode = SelectionModeEnum.ListBox Then
            If ssg.Rows.Selected.Count > 0 Then
                For i = 0 To ssg.Rows.Selected.Count - 1
                    listeIdLigne.Add(ssg.Rows.Selected(i).Item("Id"))
                Next
            End If
        Else

        End If
    End Sub

    Private Sub C1FlexGrid1_AfterSort(sender As Object, e As SortColEventArgs) Handles C1FlexGrid1.AfterSort
        Dim i As Integer
        Dim indexLigne As Integer
        Dim ssg As C1.Win.C1FlexGrid.C1FlexGrid
        ssg = sender

        If ssg.SelectionMode = SelectionModeEnum.ListBox Then
            If ssg.Rows.Selected.Count > 0 Then
                ssg.Rows(ssg.Rows.Selected(0).Index).Selected = False
                For i = 0 To listeIdLigne.Count - 1
                    indexLigne = ssg.FindRow(listeIdLigne(i), 1, ssg.Cols("Id").Index, False)
                    ssg.Rows(indexLigne).Selected = True
                Next
            End If
        Else

        End If

    End Sub

    Private Sub updateDB_Click(sender As Object, e As EventArgs) Handles updateDB.Click
        Dim sql As String = "UPDATE Customers SET Region = @p1 WHERE CustomerID = @p2"
        For Each row As Row In C1FlexGrid1.Rows.Selected
            Using conn As New SqlConnection(GetSqlConnectionString)
                Using commande = New SqlCommand(sql, conn)
                    commande.CommandType = CommandType.Text
                    commande.Parameters.AddWithValue("@p1", "Toto")
                    commande.Parameters.AddWithValue("@p2", row.Item(0))
                    conn.Open()
                    commande.ExecuteNonQuery()
                End Using
            End Using

        Next
    End Sub

    Private Function GetLastTimeStamp() As Byte()
        Dim view = _dt.AsDataView
        view.Sort = "Timestamp DESC"
        Dim row = view(0).Row
        Return row("timestamp")
    End Function

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If Not _init Then Return
        Dim timestamp = GetLastTimeStamp()
        Dim sql = "Select * from Customers where timestamp > @stamp"
        Dim command = New SqlCommand(sql)
        Dim parameter = New SqlParameter
        parameter.ParameterName = "@stamp"
        parameter.Value = timestamp
        command.Parameters.Add(parameter)
        Dim connection = New SqlConnection
        connection.ConnectionString = GetSqlConnectionString()
        command.Connection = connection

        Dim da = New SqlDataAdapter(command)

        Dim dtNew = New DataTable
        da.Fill(dtNew)
        For Each newRow As DataRow In dtNew.Rows
            Dim rows = _dt.Select($"CustomerID = '{newRow(0)}'")
            If rows Is Nothing Then Continue For
            Dim row = rows(0)
            row.ItemArray = newRow.ItemArray
            row.AcceptChanges()
        Next
    End Sub
End Class
